import {NextPage} from 'next';
import * as Iceform from '@modal-sh/iceform-next';
import {noteResource} from '@/handlers/note';

const ActionNotesResourcePage: NextPage = () => null;

const getServerSideProps = Iceform.action.getServerSideProps({
	fn: noteResource,
	onAction: async (req, res) => {
		if (req.method?.toLowerCase() === 'delete') {
			return {
				redirect: {
					destination: '/notes',
					permanent: false,
				},
			};
		}

		// use default behavior
	},
});

export {
	getServerSideProps,
	ActionNotesResourcePage as default,
};
