import { defineConfig } from 'cypress';
import { mkdir, rm, writeFile } from 'fs/promises';

export default defineConfig({
  e2e: {
    setupNodeEvents(on, config) {
      // implement node event listeners here
      on('task', {
        async 'db:reset'() {
          try {
            await rm('../iceform-next-sandbox/.db', {
              force: true,
              recursive: true,
            });
          } catch {
            // noop
          }

          try {
            await mkdir('../iceform-next-sandbox/.db');
            await writeFile('../iceform-next-sandbox/.db/notes.jsonl', '');
            return null;
          } catch {
            // noop
          }

          return undefined;
        },
        async 'db:shutdown'() {
          try {
            await rm('../iceform-next-sandbox/.db', {
              force: true,
              recursive: true,
            });
            return null;
          } catch {
            // noop
          }

          return undefined;
        },
      });
    },
  },
});
